﻿namespace ProjectCruiser.CollectionGenericObj;

public interface ICollectionGenObj<T> where T : class
{
    // Кол-во объектов в коллекции
    int Count { get; }

    // Установка max кол-ва элементов
    int SetMaxCount { set; }

    /// Добавление объекта в коллекцию
    /// <param name="obj">Добавляемый объект</param>
    /// <returns>true - вставка прошла удачно, false - вставка не удалась</returns>
    int Insert(T obj);
    int Insert(T obj, int position);

    /// Удаление объекта из коллекции с конкретной позиции
    /// <param name="position">Позиция</param>
    /// <returns>true - удаление прошло удачно, false - удаление не удалось</returns>
    T? Remove(int position);

    // Получение объекта по позиции
    T? GetItem(int position);
}
